echo off
echo .
echo .
echo This batch converts CNE NT 2009 to Mapsource 6.13 format
echo .
echo press Ctrl-C to abort
pause

if %1.xxx==.xxx goto no_source
set SRC=%~1
if exist "%SRC%Product1\CNEuroNT_2009.tdb" goto cne_ok
set SRC=%~1\
if exist "%SRC%Product1\CNEuroNT_2009.tdb" goto cne_ok

:no_source
reg QUERY HKLM\SOFTWARE\Garmin\Installed /v CNEURONT2009 > fsrc.tmp
for /F "tokens=2,*" %%I in (fsrc.tmp) do set SRC=%%J
del fsrc.tmp
if exist "%SRC%Product1\CNEuroNT_2009.tdb" goto cne_ok

reg QUERY HKLM\SOFTWARE\Wow6432Node\Garmin\Installed /v CNEURONT2009 > fsrc.tmp
for /F "tokens=2,*" %%I in (fsrc.tmp) do set SRC=%%J
del fsrc.tmp
if exist "%SRC%Product1\CNEuroNT_2009.tdb" goto cne_ok

echo .
echo Please supply source directory!
echo for example:
echo here613 "C:\ProgramData\GARMIN\Maps\City Navigator Europe NT 2009.gmap"
echo here613 "C:\Documents and Settings\All Users\Application Data\GARMIN\Maps\City Navigator Europe NT 2009.gmap"
echo .
pause
exit 1

:cne_ok
echo .
echo Source directory:
echo %SRC%
echo .
echo Output directory:
echo %~dp0
echo .
echo press Ctrl-C to abort
pause

copy "%SRC%CNEuroNT_2009.mdx"
copy "%SRC%CNEuroNT_2009_trf.trf"
copy "%SRC%I000017A.TYP"
copy "%SRC%Product1\CNEuroNT_2009.tdb"

gmt -jax -o CNEuroNT_2009_mdr.img "%SRC%CNEuroNT_2009_mdr\CNEURONT.MDR" "%SRC%CNEuroNT_2009_mdr\CNEURONT.SRT"
gmt -jax -o CNEuroNT_2009.img "%SRC%Product1\CNEuroNT_2009\CNE2009_.TRE" "%SRC%Product1\CNEuroNT_2009\CNE2009_.RGN" "%SRC%Product1\CNEuroNT_2009\CNE2009_.LBL" "%SRC%Product1\CNEuroNT_2009\CNE2009_.NET" "%SRC%Product1\CNEuroNT_2009\CNE2009_.NOD" "%SRC%Product1\CNEuroNT_2009\CNE2009_.SRT"

echo for %%%%I in ("%%~2\*.GMP") do gmt -jax -o %%1 "%%%%~I" > xgmt.bat

for /D %%I in ("%SRC%Product1\0*") do call xgmt.bat %%~nI.img "%%~I"

del xgmt.bat

echo .
echo Now this batch will install registry keys for CNE
echo press Ctrl-C to abort
echo .
pause
echo Adding registry keys.

set KEY=HKLM\SOFTWARE\Wow6432Node\Garmin\MapSource
reg QUERY %KEY% 2>NUL >NUL
if not errorlevel 1 goto key_ok
set KEY=HKLM\SOFTWARE\Garmin\MapSource
:key_ok

reg ADD %KEY%\FamiliesNT\FAMILY_378 /v ID /t REG_BINARY /d 7A01 /f
reg ADD %KEY%\FamiliesNT\FAMILY_378 /v IDX /t REG_SZ /d "%~dp0CNEuroNT_2009.mdx" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378 /v MDR /t REG_SZ /d "%~dp0CNEuroNT_2009_mdr.img" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378 /v TRF /t REG_SZ /d "%~dp0CNEuroNT_2009_trf.trf" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378 /v TYP /t REG_SZ /d "%~dp0I000017A.typ" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378\1 /v Loc /t REG_SZ /d "%~dp0\" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378\1 /v Bmap /t REG_SZ /d "%~dp0CNEuroNT_2009.img" /f
reg ADD %KEY%\FamiliesNT\FAMILY_378\1 /v Tdb /t REG_SZ /d "%~dp0CNEuroNT_2009.tdb" /f
pause
exit 0
